#include "item.h"
#include "capwap80211_items.h"
#include "capwap80211_types.h"



const char CW_RADIOITEM80211_SUPPORTED_RATES[]="802.11 supported_rates";
const char CW_RADIOITEM80211_WTP_RADIO_INFORMATION[]="802.11 radio_info";
const char CW_RADIOITEM80211_RATE_SET[]="802.11 rate set";

/* MAC Operation Items */
const char CW_RADIOITEM80211_RTS_THRESHOLD[]="rts_threshold";
const char CW_RADIOITEM80211_FRAGMENTATION_THRESHOLD[]="fragmentation_threshold";
const char CW_RADIOITEM80211_SHORT_RETRY[]="short_retry";
const char CW_RADIOITEM80211_LONG_RETRY[]="long_retry";
const char CW_RADIOITEM80211_TX_MSDU_LIFETIME[]="tx_msdu_lifetime";
const char CW_RADIOITEM80211_RX_MSDU_LIFETIME[]="rx_msdu_lifetime";

/* Radio Config Items */
const char CW_RADIOITEM80211_SHORT_PREAMBLE[]="short_preamble";
const char CW_RADIOITEM80211_NUM_BSS_IDS[]="num_bss_ids";
const char CW_RADIOITEM80211_DTIM_PERIOD[]="dtim_period";
const char CW_RADIOITEM80211_BSSID[]="bssid";
const char CW_RADIOITEM80211_BEACON_PERIOD[]="beacon_period";
const char CW_RADIOITEM80211_COUNTRY_STRING[]="country_string";


struct cw_itemdef capwap80211_itemdefs[] = {

	{CW_ITEM_NONE}

};






struct cw_itemdef capwap80211_radioitemdefs[] = {

	{CW_RADIOITEM80211_SUPPORTED_RATES,CW_ITEM_NONE,CAPWAP80211_TYPE_RATESET},
	{CW_RADIOITEM80211_RATE_SET,CW_ITEM_NONE,CAPWAP80211_TYPE_RATESET},
	{CW_RADIOITEM80211_WTP_RADIO_INFORMATION,CW_ITEM_NONE,MTYPE_DWORD},

	/* MAC Operation */
	{CW_RADIOITEM80211_RTS_THRESHOLD,CW_ITEM_NONE,MBAG_WORD},
	{CW_RADIOITEM80211_SHORT_RETRY,CW_ITEM_NONE,MBAG_BYTE},
	{CW_RADIOITEM80211_LONG_RETRY,CW_ITEM_NONE,MBAG_BYTE},
	{CW_RADIOITEM80211_FRAGMENTATION_THRESHOLD,CW_ITEM_NONE,MBAG_WORD},
	{CW_RADIOITEM80211_TX_MSDU_LIFETIME,CW_ITEM_NONE,MTYPE_DWORD},
	{CW_RADIOITEM80211_RX_MSDU_LIFETIME,CW_ITEM_NONE,MTYPE_DWORD},

	/* Radio Config Items */
	{CW_RADIOITEM80211_SHORT_PREAMBLE,CW_ITEM_NONE,MBAG_BYTE},
	{CW_RADIOITEM80211_NUM_BSS_IDS,CW_ITEM_NONE,MBAG_BYTE},
	{CW_RADIOITEM80211_DTIM_PERIOD,CW_ITEM_NONE,MBAG_BYTE},
	{CW_RADIOITEM80211_BSSID,CW_ITEM_NONE,MBAG_DATA},
	{CW_RADIOITEM80211_BEACON_PERIOD,CW_ITEM_NONE,MBAG_WORD},
	{CW_RADIOITEM80211_COUNTRY_STRING,CW_ITEM_NONE,MBAG_BSTR16},
	
	{CW_ITEM_NONE}
};
